#include "scene.h"
#include "ppc.h"
#include "linesegment.h"
#include "triangle.h"
#include "tmesh.h"

Scene *scene;

#include <iostream>

using namespace std;


Scene::Scene() {

  gui = new GUI();
  gui->show();

  int u0 = 0;
  int v0 = 0;
  int w = 640;
  int h = 480;
  fb = new FrameBuffer(u0, v0, w, h);
  fb->label("Frame Buffer");
  fb->show();

  gui->uiw->position(fb->w+20, 40);

  tmesh = new TMesh();
  tmesh->Load("geometry/teapot1K.bin");
  tmesh->Scale(50.0f);
  tmesh->TranslateTo(V3(0.0f, 0.0f, -50.0f));

  tmesh2 = 0;
#if 0
  tmesh2 = new TMesh();
  tmesh2->Load("geometry/teapot1K.bin");
  tmesh2->Scale(20.0f);
  tmesh2->TranslateTo(V3(-10.0f, 0.0f, -75.0f));
#endif

  ppc2 = 0;
  tmesh3 = 0;

  float hfov = 55.0f;
  ppc = new PPC(hfov, w, h);

  Render();

}

void Scene::DBG() {

  int w = fb->w;
  int h = fb->h;
  float hfov = 45.0f;

  ppc2 = new PPC(*ppc);

  float desiredFocalLength = 20.0f;
  fb->ClearBuffers();
  tmesh->RenderFilled(ppc2, fb);
  tmesh3 = new TMesh(fb, ppc2, ppc2->FocalLength()/desiredFocalLength);
//  tmesh3 = new TMesh(fb, ppc2);

}

void Scene::Render() {

  fb->ClearBuffers();
 
  if (tmesh)
    tmesh->RenderFilled(ppc, fb);

  if (tmesh2)
    tmesh2->RenderFilled(ppc, fb);
    
  if (tmesh3)
    tmesh3->RenderPoints(1, 0xFF000000, ppc, fb);

  float desiredFocalLength = 20.0f;
  if (ppc2)
    ppc2->Visualize(ppc, fb, desiredFocalLength, 0xFF000000);

  fb->redraw();


}